From eb934f167bf28616c8d281034f0e51d71afd5a4f Mon Sep 17 00:00:00 2001
From: Karl Semich <0xloem@gmail.com>
Date: Tue, 18 Sep 2018 00:20:37 +0000
Subject: [PATCH] add support for message commands to all devices

refactored just a little to provide for this
---
 include/osmosdr/CMakeLists.txt |   1 +
 include/osmosdr/messages.h     |  37 ++
 lib/CMakeLists.txt             |   1 +
 lib/common_iface.h             | 368 +++++++++++++++++++
 lib/dev_manager.cc             | 815 +++++++++++++++++++++++++++++++++++++++++
 lib/dev_manager.h              | 176 +++++++++
 lib/sink_iface.h               | 336 +----------------
 lib/sink_impl.cc               | 370 +++----------------
 lib/sink_impl.h                |  15 +-
 lib/source_iface.h             | 337 +----------------
 lib/source_impl.cc             | 446 +++-------------------
 lib/source_impl.h              |  20 +-
 lib/uhd/uhd_sink_c.cc          |   5 +
 lib/uhd/uhd_source_c.cc        |   5 +
 14 files changed, 1530 insertions(+), 1402 deletions(-)
 create mode 100644 include/osmosdr/messages.h
 create mode 100644 lib/common_iface.h
 create mode 100644 lib/dev_manager.cc
 create mode 100644 lib/dev_manager.h

diff --git a/include/osmosdr/CMakeLists.txt b/include/osmosdr/CMakeLists.txt
index d185ee6..6f92eaa 100644
--- a/include/osmosdr/CMakeLists.txt
+++ b/include/osmosdr/CMakeLists.txt
@@ -26,6 +26,7 @@ install(FILES
     ranges.h
     time_spec.h
     device.h
+    messages.h
     source.h
     sink.h
     DESTINATION include/osmosdr
diff --git a/include/osmosdr/messages.h b/include/osmosdr/messages.h
new file mode 100644
index 0000000..b4aacf0
--- /dev/null
+++ b/include/osmosdr/messages.h
@@ -0,0 +1,37 @@
+/* -*- c++ -*- */
+/*
+ * Copyright 2018 Karl Semich <0xloem@gmail.com>
+ *
+ * GNU Radio is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3, or (at your option)
+ * any later version.
+ *
+ * GNU Radio is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with GNU Radio; see the file COPYING.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street,
+ * Boston, MA 02110-1301, USA.
+ */
+#ifndef INCLUDED_OSMOSDR_MESSAGES_H
+#define INCLUDED_OSMOSDR_MESSAGES_H
+
+#include <pmt/pmt.h>
+
+namespace osmosdr {
+
+const pmt::pmt_t CMD_PORT = pmt::mp("command");
+const pmt::pmt_t CMD_CHAN_KEY = pmt::mp("chan");
+const pmt::pmt_t CMD_GAIN_KEY = pmt::mp("gain");
+const pmt::pmt_t CMD_FREQ_KEY = pmt::mp("freq");
+const pmt::pmt_t CMD_RATE_KEY = pmt::mp("rate");
+const pmt::pmt_t CMD_ANTENNA_KEY = pmt::mp("antenna");
+const pmt::pmt_t CMD_BANDWIDTH_KEY = pmt::mp("bandwidth");
+
+} /* namespace osmosdr */
+
+#endif /* INCLUDED_OSMOSDR_MESSAGES_H */
diff --git a/lib/CMakeLists.txt b/lib/CMakeLists.txt
index c05b8d9..d5ce7f5 100644
--- a/lib/CMakeLists.txt
+++ b/lib/CMakeLists.txt
@@ -38,6 +38,7 @@ ENDMACRO(GR_OSMOSDR_APPEND_LIBS)
 GR_OSMOSDR_APPEND_SRCS(
     source_impl.cc
     sink_impl.cc
+    dev_manager.cc
     ranges.cc
     device.cc
     time_spec.cc
diff --git a/lib/common_iface.h b/lib/common_iface.h
new file mode 100644
index 0000000..b3c6b03
--- /dev/null
+++ b/lib/common_iface.h
@@ -0,0 +1,368 @@
+/* -*- c++ -*- */
+/*
+ * Copyright 2012 Dimitri Stolnikov <horiz0n@gmx.net>
+ *
+ * GNU Radio is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3, or (at your option)
+ * any later version.
+ *
+ * GNU Radio is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with GNU Radio; see the file COPYING.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street,
+ * Boston, MA 02110-1301, USA.
+ */
+
+#ifndef OSMOSDR_COMMON_IFACE_H
+#define OSMOSDR_COMMON_IFACE_H
+
+#include <osmosdr/ranges.h>
+#include <osmosdr/time_spec.h>
+
+/*!
+ * TODO: document
+ *
+ */
+class common_iface
+{
+public:
+  /*!
+   * Get the number of channels the underlying radio hardware offers.
+   * \return the number of available channels
+   */
+  virtual size_t get_num_channels( void ) = 0;
+
+  /*!
+   * Get the possible sample rates for the underlying radio hardware.
+   * \return a range of rates in Sps
+   */
+  virtual osmosdr::meta_range_t get_sample_rates( void ) = 0;
+
+  /*!
+   * Set the sample rate for the underlying radio hardware.
+   * This also will select the appropriate IF bandpass, if applicable.
+   * \param rate a new rate in Sps
+   */
+  virtual double set_sample_rate( double rate ) = 0;
+
+  /*!
+   * Get the sample rate for the underlying radio hardware.
+   * This is the actual sample rate and may differ from the rate set.
+   * \return the actual rate in Sps
+   */
+  virtual double get_sample_rate( void ) = 0;
+
+  /*!
+   * Get the tunable frequency range for the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return the frequency range in Hz
+   */
+  virtual osmosdr::freq_range_t get_freq_range( size_t chan = 0 ) = 0;
+
+  /*!
+   * Tune the underlying radio hardware to the desired center frequency.
+   * This also will select the appropriate RF bandpass.
+   * \param freq the desired frequency in Hz
+   * \param chan the channel index 0 to N-1
+   * \return the actual frequency in Hz
+   */
+  virtual double set_center_freq( double freq, size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the center frequency the underlying radio hardware is tuned to.
+   * This is the actual frequency and may differ from the frequency set.
+   * \param chan the channel index 0 to N-1
+   * \return the frequency in Hz
+   */
+  virtual double get_center_freq( size_t chan = 0 ) = 0;
+
+  /*!
+   * Set the frequency correction value in parts per million.
+   * \param ppm the desired correction value in parts per million
+   * \param chan the channel index 0 to N-1
+   * \return correction value in parts per million
+   */
+  virtual double set_freq_corr( double ppm, size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the frequency correction value.
+   * \param chan the channel index 0 to N-1
+   * \return correction value in parts per million
+   */
+  virtual double get_freq_corr( size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the gain stage names of the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return a vector of strings containing the names of gain stages
+   */
+  virtual std::vector<std::string> get_gain_names( size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the settable overall gain range for the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return the gain range in dB
+   */
+  virtual osmosdr::gain_range_t get_gain_range( size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the settable gain range for a specific gain stage.
+   * \param name the name of the gain stage
+   * \param chan the channel index 0 to N-1
+   * \return the gain range in dB
+   */
+  virtual osmosdr::gain_range_t get_gain_range( const std::string & name,
+                                                size_t chan = 0 ) = 0;
+
+  /*!
+   * Set the gain mode for the underlying radio hardware.
+   * This might be supported only for certain hardware types.
+   * \param automatic the gain mode (true means automatic gain mode)
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain mode
+   */
+  virtual bool set_gain_mode( bool automatic, size_t chan = 0 ) { return false; }
+
+  /*!
+   * Get the gain mode selected for the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain mode (true means automatic gain mode)
+   */
+  virtual bool get_gain_mode( size_t chan = 0 ) { return false; }
+
+  /*!
+   * Set the gain for the underlying radio hardware.
+   * This function will automatically distribute the desired gain value over
+   * available gain stages in an appropriate way and return the actual value.
+   * \param gain the gain in dB
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain in dB
+   */
+  virtual double set_gain( double gain, size_t chan = 0 ) = 0;
+
+  /*!
+   * Set the named gain on the underlying radio hardware.
+   * \param gain the gain in dB
+   * \param name the name of the gain stage
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain in dB
+   */
+  virtual double set_gain( double gain,
+                           const std::string & name,
+                           size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the actual gain setting of the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain in dB
+   */
+  virtual double get_gain( size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the actual gain setting of a named stage.
+   * \param name the name of the gain stage
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain in dB
+   */
+  virtual double get_gain( const std::string & name, size_t chan = 0 ) = 0;
+
+  /*!
+   * Set the IF gain for the underlying radio hardware.
+   * This function will automatically distribute the desired gain value over
+   * available IF gain stages in an appropriate way and return the actual value.
+   * \param gain the gain in dB
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain in dB
+   */
+  virtual double set_if_gain( double gain, size_t chan = 0 ) { return 0; }
+
+  /*!
+   * Set the BB gain for the underlying radio hardware.
+   * This function will automatically distribute the desired gain value over
+   * available BB gain stages in an appropriate way and return the actual value.
+   * \param gain the gain in dB
+   * \param chan the channel index 0 to N-1
+   * \return the actual gain in dB
+   */
+  virtual double set_bb_gain( double gain, size_t chan = 0 ) { return 0; }
+
+  /*!
+   * Get the available antennas of the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return a vector of strings containing the names of available antennas
+   */
+  virtual std::vector< std::string > get_antennas( size_t chan = 0 ) = 0;
+
+  /*!
+   * Select the active antenna of the underlying radio hardware.
+   * \param chan the channel index 0 to N-1
+   * \return the actual antenna's name
+   */
+  virtual std::string set_antenna( const std::string & antenna,
+                                   size_t chan = 0 ) = 0;
+
+  /*!
+   * Get the actual underlying radio hardware antenna setting.
+   * \param chan the channel index 0 to N-1
+   * \return the actual antenna's name
+   */
+  virtual std::string get_antenna( size_t chan = 0 ) = 0;
+
+  /*!
+   * Set the frontend DC offset value.
+   * The value is complex to control both I and Q.
+   * For RX, only set this when automatic correction is disabled.
+   *
+   * \param offset the dc offset (1.0 is full-scale)
+   * \param chan the channel index 0 to N-1
+   */
+  virtual void set_dc_offset( const std::complex<double> &offset, size_t chan = 0 ) { }
+
+  /*!
+   * Set the frontend IQ balance correction.
+   * Use this to adjust the magnitude and phase of I and Q.
+   *
+   * \param balance the complex correction value
+   * \param chan the channel index 0 to N-1
+   */
+  virtual void set_iq_balance( const std::complex<double> &balance, size_t chan = 0 ) { }
+
+  /*!
+   * Set the bandpass filter on the radio frontend.
+   * \param bandwidth the filter bandwidth in Hz, set to 0 for automatic selection
+   * \param chan the channel index 0 to N-1
+   * \return the actual filter bandwidth in Hz
+   */
+  virtual double set_bandwidth( double bandwidth, size_t chan = 0 ) { return 0; }
+
+  /*!
+   * Get the actual bandpass filter setting on the radio frontend.
+   * \param chan the channel index 0 to N-1
+   * \return the actual filter bandwidth in Hz
+   */
+  virtual double get_bandwidth( size_t chan = 0 ) { return 0; }
+
+  /*!
+   * Get the possible bandpass filter settings on the radio frontend.
+   * \param chan the channel index 0 to N-1
+   * \return a range of bandwidths in Hz
+   */
+  virtual osmosdr::freq_range_t get_bandwidth_range( size_t chan = 0 )
+    { return osmosdr::freq_range_t(); }
+
+  /*!
+   * Set the time source for the device.
+   * This sets the method of time synchronization,
+   * typically a pulse per second or an encoded time.
+   * Typical options for source: external, MIMO.
+   * \param source a string representing the time source
+   * \param mboard which motherboard to set the config
+   */
+  virtual void set_time_source(const std::string &source,
+                               const size_t mboard = 0) { }
+
+  /*!
+   * Get the currently set time source.
+   * \param mboard which motherboard to get the config
+   * \return the string representing the time source
+   */
+  virtual std::string get_time_source(const size_t mboard) { return ""; }
+
+  /*!
+   * Get a list of possible time sources.
+   * \param mboard which motherboard to get the list
+   * \return a vector of strings for possible settings
+   */
+  virtual std::vector<std::string> get_time_sources(const size_t mboard)
+  {
+    return std::vector<std::string>();
+  }
+
+  /*!
+   * Set the clock source for the device.
+   * This sets the source for a 10 Mhz reference clock.
+   * Typical options for source: internal, external, MIMO.
+   * \param source a string representing the clock source
+   * \param mboard which motherboard to set the config
+   */
+  virtual void set_clock_source(const std::string &source,
+                                const size_t mboard = 0) { }
+
+  /*!
+   * Get the currently set clock source.
+   * \param mboard which motherboard to get the config
+   * \return the string representing the clock source
+   */
+  virtual std::string get_clock_source(const size_t mboard) { return ""; }
+
+  /*!
+   * Get a list of possible clock sources.
+   * \param mboard which motherboard to get the list
+   * \return a vector of strings for possible settings
+   */
+  virtual std::vector<std::string> get_clock_sources(const size_t mboard)
+  {
+    return std::vector<std::string>();
+  }
+
+  /*!
+   * Get the master clock rate.
+   * \param mboard the motherboard index 0 to M-1
+   * \return the clock rate in Hz
+   */
+  virtual double get_clock_rate(size_t mboard = 0) { return 0; }
+
+  /*!
+   * Set the master clock rate.
+   * \param rate the new rate in Hz
+   * \param mboard the motherboard index 0 to M-1
+   */
+  virtual void set_clock_rate(double rate, size_t mboard = 0) { }
+
+  /*!
+   * Get the current time registers.
+   * \param mboard the motherboard index 0 to M-1
+   * \return the current device time
+   */
+  virtual ::osmosdr::time_spec_t get_time_now(size_t mboard = 0)
+  {
+    return ::osmosdr::time_spec_t::get_system_time();
+  }
+
+  /*!
+   * Get the time when the last pps pulse occured.
+   * \param mboard the motherboard index 0 to M-1
+   * \return the current device time
+   */
+  virtual ::osmosdr::time_spec_t get_time_last_pps(size_t mboard = 0)
+  {
+    return ::osmosdr::time_spec_t::get_system_time();
+  }
+
+  /*!
+   * Sets the time registers immediately.
+   * \param time_spec the new time
+   * \param mboard the motherboard index 0 to M-1
+   */
+  virtual void set_time_now(const ::osmosdr::time_spec_t &time_spec,
+                            size_t mboard = 0) { }
+
+  /*!
+   * Set the time registers at the next pps.
+   * \param time_spec the new time
+   */
+  virtual void set_time_next_pps(const ::osmosdr::time_spec_t &time_spec) { }
+
+  /*!
+   * Sync the time registers with an unknown pps edge.
+   * \param time_spec the new time
+   */
+  virtual void set_time_unknown_pps(const ::osmosdr::time_spec_t &time_spec) { }
+};
+
+#endif // OSMOSDR_COMMON_IFACE_H
diff --git a/lib/dev_manager.h b/lib/dev_manager.h
new file mode 100644
index 0000000..416573f
--- /dev/null
+++ b/lib/dev_manager.h
@@ -0,0 +1,176 @@
+/* -*- c++ -*- */
+/*
+ * Copyright 2018 Karl Semich <0xloem@gmail.com>
+ *
+ * This file is part of GNU Radio
+ *
+ * GNU Radio is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3, or (at your option)
+ * any later version.
+ *
+ * GNU Radio is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with GNU Radio; see the file COPYING.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street,
+ * Boston, MA 02110-1301, USA.
+ */
+
+#ifndef INCLUDED_DEV_CONTROL_H
+#define INCLUDED_DEV_CONTROL_H
+
+#include <gnuradio/hier_block2.h>
+#include <gnuradio/block.h>
+
+#include <osmosdr/messages.h>
+
+#include "common_iface.h"
+
+class dev_manager;
+
+/*
+ * We use boost::shared_ptr's instead of raw pointers for all access
+ * to gr::blocks (and many other data structures).  The shared_ptr gets
+ * us transparent reference counting, which greatly simplifies storage
+ * management issues.  This is especially helpful in our hybrid
+ * C++ / Python system.
+ *
+ * See http://www.boost.org/libs/smart_ptr/smart_ptr.htm
+ *
+ * As a convention, the _sptr suffix indicates a boost::shared_ptr
+ */
+typedef boost::shared_ptr<dev_manager> dev_manager_sptr;
+
+/*!
+ * \brief Return a shared_ptr to a new instance of dev_manager.
+ *
+ * To avoid accidental use of raw pointers, dev_manager's
+ * constructor is private. make_dev_manager is the public
+ * interface for creating new instances.
+ */
+dev_manager_sptr make_dev_manager ( gr::hier_block2_sptr outer );
+
+/*!
+ * \brief Manages a set of osmosdr devices.
+ * \ingroup block
+ *
+ */
+class dev_manager : public gr::block
+{
+private:
+  // The friend declaration allows make_dev_manager to
+  // access the private constructor.
+
+  friend dev_manager_sptr make_dev_manager ( gr::hier_block2_sptr outer );
+
+  /*!
+   * \brief Manages a set of osmosdr devices.
+   */
+  dev_manager ( gr::hier_block2_sptr outer );    // private constructor
+
+public:
+  int general_work( int noutput_items,
+                    gr_vector_int &ninput_items,
+                    gr_vector_const_void_star &input_items,
+                    gr_vector_void_star &output_items );
+
+  void add_device( gr::basic_block_sptr block, common_iface *iface ); // add a device driver block to be managed
+  size_t get_num_mboards() const;
+  size_t get_mboard_for_channel( size_t chan ) const;
+  bool is_sink( size_t mboard = 0 ) const;
+  gr::basic_block_sptr get_block( size_t mboard ) const;
+  common_iface * get_iface( size_t mboard ) const;
+  size_t get_mboard_channel( size_t mboard ) const;
+
+  size_t get_num_channels();
+
+  bool seek( long seek_point, int whence, size_t chan);
+
+  osmosdr::meta_range_t get_sample_rates( void );
+  double set_sample_rate( double rate );
+  double get_sample_rate( void );
+
+  osmosdr::freq_range_t get_freq_range( size_t chan );
+  double set_center_freq( double freq, size_t chan );
+  double get_center_freq( size_t chan );
+  double set_freq_corr( double ppm, size_t chan );
+  double get_freq_corr( size_t chan );
+
+  std::vector<std::string> get_gain_names( size_t chan );
+  osmosdr::gain_range_t get_gain_range( size_t chan );
+  osmosdr::gain_range_t get_gain_range( const std::string & name, size_t chan );
+  bool set_gain_mode( bool automatic, size_t chan );
+  bool get_gain_mode( size_t chan );
+  double set_gain( double gain, size_t chan );
+  double set_gain( double gain, const std::string & name, size_t chan );
+  double get_gain( size_t chan );
+  double get_gain( const std::string & name, size_t chan );
+
+  double set_if_gain( double gain, size_t chan );
+  double set_bb_gain( double gain, size_t chan );
+
+  std::vector< std::string > get_antennas( size_t chan );
+  std::string set_antenna( const std::string & antenna, size_t chan );
+  std::string get_antenna( size_t chan );
+
+  void set_dc_offset_mode( int mode, size_t chan );
+  void set_dc_offset( const std::complex<double> &offset, size_t chan );
+
+  void set_iq_balance_mode( int mode, size_t chan );
+  void set_iq_balance( const std::complex<double> &balance, size_t chan );
+
+  double set_bandwidth( double bandwidth, size_t chan );
+  double get_bandwidth( size_t chan );
+  osmosdr::freq_range_t get_bandwidth_range( size_t chan );
+
+  void set_time_source(const std::string &source, const size_t mboard = 0);
+  std::string get_time_source(const size_t mboard);
+  std::vector<std::string> get_time_sources(const size_t mboard);
+  void set_clock_source(const std::string &source, const size_t mboard = 0);
+  std::string get_clock_source(const size_t mboard);
+  std::vector<std::string> get_clock_sources(const size_t mboard);
+  double get_clock_rate(size_t mboard = 0);
+  void set_clock_rate(double rate, size_t mboard = 0);
+  ::osmosdr::time_spec_t get_time_now(size_t mboard = 0);
+  ::osmosdr::time_spec_t get_time_last_pps(size_t mboard = 0);
+  void set_time_now(const ::osmosdr::time_spec_t &time_spec, size_t mboard = 0);
+  void set_time_next_pps(const ::osmosdr::time_spec_t &time_spec);
+  void set_time_unknown_pps(const ::osmosdr::time_spec_t &time_spec);
+
+private:
+  void msg_handler_command(pmt::pmt_t msg);
+  void exec_msg_cmd(const pmt::pmt_t &cmd, const pmt::pmt_t &val, size_t chan);
+
+  struct dev_t {
+    common_iface * dev;
+    gr::basic_block_sptr block;
+    size_t chan;
+  };
+
+  std::vector< dev_t > _devs;
+  std::vector< size_t > _chandevs;
+  gr::hier_block2_sptr _outer;
+  size_t _channels;
+
+  /* cache to prevent multiple device calls with the same value coming from grc */
+  double _sample_rate;
+  std::map< size_t, double > _center_freq;
+  std::map< size_t, double > _freq_corr;
+  std::map< size_t, bool > _gain_mode;
+  std::map< size_t, double > _gain;
+  std::map< size_t, double > _if_gain;
+  std::map< size_t, double > _bb_gain;
+  std::map< size_t, std::string > _antenna;
+#ifdef HAVE_IQBALANCE
+  std::vector< gr::iqbalance::fix_cc * > _iq_fix;
+  std::vector< gr::iqbalance::optimize_c * > _iq_opt;
+  std::map< size_t, std::pair<float, float> > _vals;
+#endif
+  std::map< size_t, double > _bandwidth;
+};
+
+#endif /* INCLUDED_DEV_CONTROL_H */
